package rest_handler

import (
	"encoding/base64"
	"net/http"

	"gitea.elara.ws/Hazel/hangman/internal/game"
	"github.com/labstack/echo/v4"
)

func CreateUser(c echo.Context) error {
	session := game.GetSession(c.Param("session"))

	type BodyContent struct {
		Name      string
		PublicKey string
	}
	var bodyContent BodyContent

	err := c.Bind(&bodyContent)
	if err != nil {
		return c.String(http.StatusBadRequest, err.Error())
	}

	pub, _ := base64.StdEncoding.DecodeString(bodyContent.PublicKey)
	user := game.NewUser(bodyContent.Name, pub)
	session.AddUser(user)

	return c.JSON(http.StatusOK, user)
}
